// karambasaver - A KDE screensaver using Karamba themes
// Copyright (c) Bosselut Cyril
//
// Using Screensaver Template from KDevelop
// Copyright (c)  Ian Reinhart Geiser
//

#include "karambasaver.h"
#include "karambasaverui.h"

static const char *description = I18N_NOOP("A KDE Screensaver usin Karamba Library");
static const char *version = "0.1";
// libkscreensaver interface
extern "C"{
    const char *kss_applicationName = "karambasaver.kss";
    const char *kss_description = I18N_NOOP( "karambasaver" );
    const char *kss_version = "2.2.0";

    karambasaver *kss_create( WId id ){
        KGlobal::locale()->insertCatalogue("karambasaver");
        return new karambasaver( id );
    }

    QDialog *kss_setup(){
        KGlobal::locale()->insertCatalogue("karambasaver");
        return new karambasaverSetup();
    }
}

//-----------------------------------------------------------------------------
// dialog to setup screen saver parameters
//
karambasaverSetup::karambasaverSetup( QWidget *parent, const char *name )
        : karambasaverUI( parent, name, TRUE ){
    /// @todo
    //Connect your signals and slots here to configure the screen saver.
    KAboutData about("karamba", I18N_NOOP("karamba"), version, description,
    KAboutData::License_GPL, "(C) 2003 Cyril Bosselut", 0, 0, "bosselut@b1project.com");
    about.addAuthor( "Cyril Bosselut",0 , "bosselut@b1project.com" );
    about.setTranslator(I18N_NOOP("INSERT YOUR NAME HERE"),I18N_NOOP("INSERT YOUR EMAIL ADDRESS"));

    connect( OkayPushButton, SIGNAL( released() ),
             SLOT( slotOkPressed() ) );
    connect( CancelPushButton, SIGNAL( released() ),
             SLOT( slotCancelPressed() ) );
}

// Ok pressed - save settings and exit

void karambasaverSetup::slotOkPressed(){
  KSimpleConfig conf("karambasaverrc", false);
  conf.setGroup("Settings");
  conf.writeEntry("DefaultTheme", dTheme->text());
  conf.sync();
  accept();
}

void karambasaverSetup::slotCancelPressed(){
    reject();
}
//-----------------------------------------------------------------------------


karambasaver::karambasaver( WId id ) : KScreenSaver( id ){
    readSettings();
    blank();
}

karambasaver::~karambasaver(){
  k->close();
}

// read configuration settings from config file


void karambasaver::readSettings(){
  KSimpleConfig conf("karambasaverrc",true);
  conf.setGroup("Settings");
  theme =  conf.readEntry("DefaultTheme", "");
}


void karambasaver::blank(){
    setBackgroundColor( QColor(black)  );
    qDebug("loading theme " + theme);
    k = new karamba(this, theme, true);
    k->show();
    erase();
}

